
import java.util.*;

public abstract class StamperWheel  {

	/**
	 *  The symbols for a particular wheel
	 */
	private String symbols_;
	public String symbols() { return symbols_; }
	public void symbols( String aString ) { symbols_ = aString; }

	/**
	 *  The position of the current symbol
	 */
	private int currentSymbolPosition_;
	public int currentSymbolPosition() { return currentSymbolPosition_; }
	public void currentSymbolPosition( int anInt ) { currentSymbolPosition_ = anInt; }

	/**
	 *  The wheel that get incremented when this wheel
	 *  completes a rotation
	 */
	private StamperWheel superiorWheel_;
	public StamperWheel superiorWheel() { return superiorWheel_; }
	public void superiorWheel( StamperWheel aStamperWheel ) { superiorWheel_ = aStamperWheel; }
    
    protected StamperWheel()  {
        this.initialize();
    }
    
    public StamperWheel(StamperWheel superiorWheel)  {
        this();
        this.superiorWheel(superiorWheel);
    }
    
    private void initialize() {
        System.out.println("inside stamper wheel initialize");
        this.symbols("X");
        this.currentSymbolPosition(0);
    }
    
    public void advancePosition() {
        if (this.currentSymbolPosition() >= this.symbols().length()-1) {
            this.currentSymbolPosition(0);
            this.generateCarry();
        }
        else  {
            this.currentSymbolPosition(this.currentSymbolPosition()+1);
        }
    }
    
    public String toString()  {
        return String.valueOf(this.symbols().charAt(this.currentSymbolPosition()));
    }
    
    public void generateCarry()  {
        if (this.superiorWheel() == null)  {
            System.out.println("Call the Governor .. we have problems");
        }
        this.superiorWheel().advancePosition();
    }
}